#include <iostream>
#include <regex>
#include "rational.h"
using namespace std;

//calculator routine
int calc(){
	try{
    cout << endl << "Welcome to the calculator." << endl;
	cout << "Syntax: [rational][operator][rational]" << endl;
	cout << "Or, enter q to quit." << endl << endl;
	//string vectorizing fn from http://stackoverflow.com/a/237280
	bool inputgood, inputdivchoicegood;
	string str, dividechoicein;
	string chunk1, chunk2, chunk3;
	string truthiness;
	int switcher = -1;
	int dividechoice;
	std::vector<std::string> parsecalc;
	rational r1;
	rational r2;
	rational r1temp;
	rational r2temp;

	//different kinds of possible expressions
	//these have a unique char to split by, so are trivial to do so:
	regex iquit("^(q|Q)$"); //0
	regex rgxplus("^-?[0-9]{1,9}(/-?[0-9]{1,9})?\\+-?[0-9]{1,9}(/-?[0-9]{1,9})?$"); //1
	regex rgxmult("^-?[0-9]{1,9}(/-?[0-9]{1,9})?\\*-?[0-9]{1,9}(/-?[0-9]{1,9})?$"); //2
	regex rgxequals("^-?[0-9]{1,9}(/-?[0-9]{1,9})?=-?[0-9]{1,9}(/-?[0-9]{1,9})?$"); //3
	regex rgxless("^-?[0-9]{1,9}(/-?[0-9]{1,9})?<-?[0-9]{1,9}(/-?[0-9]{1,9})?$"); //4
	regex rgxgreater("^-?[0-9]{1,9}(/-?[0-9]{1,9})?>-?[0-9]{1,9}(/-?[0-9]{1,9})?$"); //5
	//...divide signs are a bit more complicated:
	regex rgxdivide1("^-?[0-9]{1,9}/-?[0-9]{1,9}$"); //6 (one /)
	regex rgxdivide2("^-?[0-9]{1,9}/-?[0-9]{1,9}/-?[0-9]{1,9}$"); //7 (two / - must ask what user means)
	regex rgxdivide3("^-?[0-9]{1,9}/-?[0-9]{1,9}/-?[0-9]{1,9}/-?[0-9]{1,9}$"); //8 (three /)
	//...minus signs make you want to scream and shout:
	//n-n and simplest general cases (series 1)
	regex rgxminus11("^[0-9]{1,9}(/[0-9]{1,9})?-[0-9]{1,9}(/[0-9]{1,9})?$"); //11 nominuses-nominuses
	regex rgxminus12("^[0-9]{1,9}(/[0-9]{1,9})?--[0-9]{1,9}(/[0-9]{1,9})?$"); //12 nominuses-leadingminusonly
	regex rgxminus13("^-[0-9]{1,9}(/[0-9]{1,9})?-[0-9]{1,9}(/[0-9]{1,9})?$"); //13 leadingminusonly-nominuses
	regex rgxminus14("^-[0-9]{1,9}(/[0-9]{1,9})?--[0-9]{1,9}(/[0-9]{1,9})?$"); //14 leadingminusonly-leadingminusonly
	//n/n-n, n/n-n/n cases (series 2)
	regex rgxminus23("^[0-9]{1,9}/-[0-9]{1,9}-[0-9]{1,9}(/[0-9]{1,9})?$"); //23 trailingminusonly-nominuses
    regex rgxminus24("^[0-9]{1,9}/-[0-9]{1,9}--[0-9]{1,9}(/[0-9]{1,9})?$"); //24 trailingminusonly-leadingminusonly
	regex rgxminus27("^-[0-9]{1,9}/-[0-9]{1,9}-[0-9]{1,9}(/[0-9]{1,9})?$"); //27 dualminus-nominus
	regex rgxminus28("^-[0-9]{1,9}/-[0-9]{1,9}--[0-9]{1,9}(/[0-9]{1,9})?$"); //28 dualminus-leadingminusonly
	//n-n/n, n/n-n/n cases (series 3)
	regex rgxminus32("^[0-9]{1,9}(/[0-9]{1,9})?-[0-9]{1,9}/-[0-9]{1,9}$"); //32 nominus-trailingminusonly
	regex rgxminus34("^[0-9]{1,9}(/[0-9]{1,9})?--[0-9]{1,9}/-[0-9]{1,9}$"); //34 nominus-dualminus
	regex rgxminus36("^-[0-9]{1,9}(/[0-9]{1,9})?-[0-9]{1,9}/-[0-9]{1,9}$"); //36 leadingminusonly-trailingminusonly
	regex rgxminus38("^-[0-9]{1,9}(/[0-9]{1,9})?--[0-9]{1,9}/-[0-9]{1,9}$"); //38 leadingminusonly-dualminus
	//special n/n-n/n cases (series 4)
	regex rgxminus46("^[0-9]{1,9}/-[0-9]{1,9}-[0-9]{1,9}/-[0-9]{1,9}$"); //46 trailingminusonly-trailingminusonly
	regex rgxminus48("^[0-9]{1,9}/-[0-9]{1,9}--[0-9]{1,9}/-[0-9]{1,9}$"); //48 trailingminusonly-dualminus
	regex rgxminus54("^-[0-9]{1,9}/-[0-9]{1,9}-[0-9]{1,9}/-[0-9]{1,9}$"); //54 dualminus-trailingminusonly
    regex rgxminus56("^-[0-9]{1,9}/-[0-9]{1,9}--[0-9]{1,9}/-[0-9]{1,9}$"); //56 dualminus-dualminus
	
	//calculator while (the return statement we need is inside)
	while (!cin.fail())
	{
		switcher = -1;
		inputgood = false;
		cout << "Calculate: ";
	//input while
	while (!inputgood && !cin.fail())
	{
	str = ""; //clear string
	getline(cin, str);
	if (cin.eof()) return -1; //if someone inputs Ctrl+Z
	//check to make sure expression is valid and what kind we're dealing with
	if (std::regex_match(str,iquit))
	{switcher = 0;
	inputgood = true;}
	else if (std::regex_match(str,rgxplus))
	{switcher = 1;
	inputgood = true;}
	else if (std::regex_match(str,rgxmult))
	{switcher = 2;
	inputgood = true;}
	else if (std::regex_match(str,rgxequals))
	{switcher = 3;
	inputgood = true;}
	else if (std::regex_match(str,rgxless))
	{switcher = 4;
	inputgood = true;}
	else if (std::regex_match(str,rgxgreater))
	{switcher = 5;
	inputgood = true;}
	else if (std::regex_match(str,rgxdivide1))
	{switcher = 6;
	inputgood = true;}
	else if (std::regex_match(str,rgxdivide2))
	{switcher = 7;
	inputgood = true;}
    else if (std::regex_match(str,rgxdivide3))
	{switcher = 8;
	inputgood = true;}
	else if (std::regex_match(str,rgxminus11))
	{switcher = 11;
	inputgood = true;}
	else if (std::regex_match(str,rgxminus12))
	{switcher = 12;
	inputgood = true;}
	else if (std::regex_match(str,rgxminus13))
	{switcher = 13;
	inputgood = true;}
	else if (std::regex_match(str,rgxminus14))
	{switcher = 14;
	inputgood = true;}
	else if (std::regex_match(str,rgxminus23))
	{switcher = 23;
	inputgood = true;}
	else if (std::regex_match(str,rgxminus24))
	{switcher = 24;
	inputgood = true;}
	else if (std::regex_match(str,rgxminus27))
	{switcher = 27;
	inputgood = true;}
	else if (std::regex_match(str,rgxminus28))
	{switcher = 28;
	inputgood = true;}
	else if (std::regex_match(str,rgxminus32))
	{switcher = 32;
	inputgood = true;}
	else if (std::regex_match(str,rgxminus34))
	{switcher = 34;
	inputgood = true;}
	else if (std::regex_match(str,rgxminus36))
	{switcher = 36;
	inputgood = true;}
	else if (std::regex_match(str,rgxminus38))
	{switcher = 38;
	inputgood = true;}
	else if (std::regex_match(str,rgxminus46))
	{switcher = 46;
	inputgood = true;}
	else if (std::regex_match(str,rgxminus48))
	{switcher = 48;
	inputgood = true;}
	else if (std::regex_match(str,rgxminus54))
	{switcher = 54;
	inputgood = true;}
	else if (std::regex_match(str,rgxminus56))
	{switcher = 56;
	inputgood = true;}
	else {
		//input failed
		cerr << "\nInput failed! Please try again: ";
	}
	}//end input while

	//do operations or quit
	switch (switcher)
		{
		  case 0://quit
			 cout << endl << "Thanks for using the calculator. Goodbye!" << endl;
	         return 0;
			 break;
		  case 1://add
			 parsecalc = split(str, '+');
	         if (parsecalc.size() > 0) r1 = rational(parsecalc[0]);
	         if (parsecalc.size() > 1) r2 = rational(parsecalc[1]);
	         cout << endl << r1 + r2 << endl << endl;
			 break;
		  case 2://multiply
			 parsecalc = split(str, '*');
	         if (parsecalc.size() > 0) r1 = rational(parsecalc[0]);
	         if (parsecalc.size() > 1) r2 = rational(parsecalc[1]);
	         cout << endl << r1 * r2 << endl << endl;
			 break;
          case 3://equals?
			 parsecalc = split(str, '=');
	         if (parsecalc.size() > 0) r1 = rational(parsecalc[0]);
	         if (parsecalc.size() > 1) r2 = rational(parsecalc[1]);
			 if (r1 == r2) truthiness = "True.";
			 else truthiness = "False.";
	         cout << endl << truthiness << endl << endl;
			 break;
		  case 4://less than
			 parsecalc = split(str, '<');
	         if (parsecalc.size() > 0) r1 = rational(parsecalc[0]);
	         if (parsecalc.size() > 1) r2 = rational(parsecalc[1]);
			 if (r1 < r2) truthiness = "True.";
			 else truthiness = "False.";
	         cout << endl << truthiness << endl << endl;
			 break;
		  case 5://greater than
			 parsecalc = split(str, '>');
	         if (parsecalc.size() > 0) r1 = rational(parsecalc[0]);
	         if (parsecalc.size() > 1) r2 = rational(parsecalc[1]);
			 if (r1 > r2) truthiness = "True.";
			 else truthiness = "False.";
	         cout << endl << truthiness << endl << endl;
			 break;
	      case 6://divide, easy case of one /
			 parsecalc = split(str, '/');
	         if (parsecalc.size() > 0) r1 = rational(parsecalc[0]);
	         if (parsecalc.size() > 1) r2 = rational(parsecalc[1]);
	         cout << endl << r1 / r2 << endl << endl;
			 break;
		  case 7://divide, tricky case of two /
			 //needs to distinguish between, say, 5 / 1/2 and 5/1 / 2
			 inputdivchoicegood = false;
			 dividechoice = 0;
			 parsecalc = split(str, '/');
			 chunk1, chunk2, chunk3 = "";
	         if (parsecalc.size() > 0) chunk1 = parsecalc[0];
	         if (parsecalc.size() > 1) chunk2 = parsecalc[1];
			 if (parsecalc.size() > 2) chunk3 = parsecalc[2];
			 r1 = rational(chunk1 + "/" + chunk2);
			 r2 = rational(chunk3);
			 r1temp = rational(chunk1);
			 r2temp = rational(chunk2 + "/" + chunk3);
			 cout << endl << "Did you mean [1]: " << r1 << " divided by " << r2 << endl;
			 cout << "or [2]: " << r1temp << " divided by " << r2temp << "? ";
			 while (!inputdivchoicegood && !cin.fail())
	         {
	            dividechoicein = ""; //clear string
	            getline(cin, dividechoicein);
				if (cin.eof()) return -1; //if someone inputs Ctrl+Z
				if (dividechoicein.compare("1") == 0){
					dividechoice = 1;
					inputdivchoicegood = true;
				}
				else if (dividechoicein.compare("2") == 0){
					dividechoice = 2;
					inputdivchoicegood = true;
				}
				else cout << endl << "Invalid choice. Try again: ";
			 }
	         if (dividechoice == 1) cout << endl << r1 / r2 << endl << endl;
			 else if (dividechoice == 2) cout << endl << r1temp / r2temp << endl << endl;
			 break;
		  case 8://divide, three /
			 parsecalc = split(str, '/');
	         if (parsecalc.size() >= 2) r1 = rational(parsecalc[0] + "/" + parsecalc[1]);
	         if (parsecalc.size() >= 4) r2 = rational(parsecalc[2] + "/" + parsecalc[3]);
	         cout << endl << r1 / r2 << endl << endl;
			 break;
		  //begin minus case handling - refer to regex block above for details
		  //nominuses-nominuses
		  case 11:
			 parsecalc = split(str, '-');
	         if (parsecalc.size() > 0) r1 = rational(parsecalc[0]);
	         if (parsecalc.size() > 1) r2 = rational(parsecalc[1]);
	         cout << endl << r1 - r2 << endl << endl;
			 break;
		  //nominuses-leadingminusonly
		  case 12:
			 parsecalc = split(str, '-');
	         if (parsecalc.size() > 0) r1 = rational(parsecalc[0]);
	         if (parsecalc.size() > 2) r2 = rational("-" + parsecalc[2]);
	         cout << endl << r1 - r2 << endl << endl;
			 break;
		  //leadingminusonly-nominuses
		  case 13:
			 parsecalc = split(str, '-');
	         if (parsecalc.size() > 1) r1 = rational("-" + parsecalc[1]);
	         if (parsecalc.size() > 2) r2 = rational(parsecalc[2]);
	         cout << endl << r1 - r2 << endl << endl;
			 break;
		  //leadingminusonly-leadingminusonly
		  case 14:
			 parsecalc = split(str, '-');
	         if (parsecalc.size() > 1) r1 = rational("-" + parsecalc[1]);
	         if (parsecalc.size() > 3) r2 = rational("-" + parsecalc[3]);
	         cout << endl << r1 - r2 << endl << endl;
			 break;
		  //trailingminusonly-nominuses
		  case 23:
			 parsecalc = split(str, '-');
	         if (parsecalc.size() > 1) r1 = rational(parsecalc[0] + "-" + parsecalc[1]);
	         if (parsecalc.size() > 2) r2 = rational(parsecalc[2]);
	         cout << endl << r1 - r2 << endl << endl;
			 break;
		  //trailingminusonly-leadingminusonly
		  case 24:
			 parsecalc = split(str, '-');
	         if (parsecalc.size() > 1) r1 = rational(parsecalc[0] + "-" + parsecalc[1]);
	         if (parsecalc.size() > 3) r2 = rational("-" + parsecalc[3]);
	         cout << endl << r1 - r2 << endl << endl;
			 break;
		  //dualminus-nominuses
		  case 27:
			 parsecalc = split(str, '-');
	         if (parsecalc.size() > 2) r1 = rational("-" + parsecalc[1] + "-" + parsecalc[2]);
	         if (parsecalc.size() > 3) r2 = rational(parsecalc[3]);
	         cout << endl << r1 - r2 << endl << endl;
			 break;
		  //dualminus-leadingminusonly
		  case 28:
			 parsecalc = split(str, '-');
	         if (parsecalc.size() > 2) r1 = rational("-" + parsecalc[1] + "-" + parsecalc[2]);
	         if (parsecalc.size() > 4) r2 = rational("-" + parsecalc[4]);
	         cout << endl << r1 - r2 << endl << endl;
			 break;
		  //nominuses-trailingminusonly
		  case 32:
			 parsecalc = split(str, '-');
	         if (parsecalc.size() > 0) r1 = rational(parsecalc[0]);
	         if (parsecalc.size() > 2) r2 = rational(parsecalc[1] + "-" + parsecalc[2]);
	         cout << endl << r1 - r2 << endl << endl;
			 break;
		  //nominuses-dualminus
		  case 34:
			 parsecalc = split(str, '-');
	         if (parsecalc.size() > 0) r1 = rational(parsecalc[0]);
	         if (parsecalc.size() > 3) r2 = rational("-" + parsecalc[2] + "-" + parsecalc[3]);
	         cout << endl << r1 - r2 << endl << endl;
			 break;
		  //leadingminusonly-trailingminusonly
		  case 36:
			 parsecalc = split(str, '-');
	         if (parsecalc.size() > 1) r1 = rational("-" + parsecalc[1]);
	         if (parsecalc.size() > 3) r2 = rational(parsecalc[2] + "-" + parsecalc[3]);
	         cout << endl << r1 - r2 << endl << endl;
			 break;
		  //leadingminusonly-dualminus
		  case 38:
			 parsecalc = split(str, '-');
	         if (parsecalc.size() > 1) r1 = rational("-" + parsecalc[1]);
	         if (parsecalc.size() > 4) r2 = rational("-" + parsecalc[3] + "-" + parsecalc[4]);
	         cout << endl << r1 - r2 << endl << endl;
			 break;
		  //trailingminusonly-trailingminusonly
		  case 46:
			 parsecalc = split(str, '-');
	         if (parsecalc.size() > 1) r1 = rational(parsecalc[0] + "-" + parsecalc[1]);
	         if (parsecalc.size() > 3) r2 = rational(parsecalc[2] + "-" + parsecalc[3]);
	         cout << endl << r1 - r2 << endl << endl;
			 break;
		  //trailingminusonly-dualminus
		  case 48:
			 parsecalc = split(str, '-');
	         if (parsecalc.size() > 1) r1 = rational(parsecalc[0] + "-" + parsecalc[1]);
	         if (parsecalc.size() > 4) r2 = rational("-" + parsecalc[3] + "-" + parsecalc[4]);
	         cout << endl << r1 - r2 << endl << endl;
			 break;
		  //dualminus-trailingminusonly
		  case 54:
			 parsecalc = split(str, '-');
	         if (parsecalc.size() > 2) r1 = rational("-" + parsecalc[1] + "-" + parsecalc[2]);
	         if (parsecalc.size() > 4) r2 = rational(parsecalc[3] + "-" + parsecalc[4]);
	         cout << endl << r1 - r2 << endl << endl;
			 break;
		  //dualminus-dualminus
		  case 56:
			 parsecalc = split(str, '-');
	         if (parsecalc.size() > 2) r1 = rational("-" + parsecalc[1] + "-" + parsecalc[2]);
	         if (parsecalc.size() > 5) r2 = rational("-" + parsecalc[4] + "-" + parsecalc[5]);
	         cout << endl << r1 - r2 << endl << endl;
			 break;
  		  default:
			 cout << endl << "Type " << switcher << " not yet implemented or invalid." << endl << endl;
		}//end switch
	}//end calculator while
	    return 0;
	}//end try
	catch (...){
	    cout << "An error occured. Exiting now.";
		return -1;
	}//end catch

}//end calculator

//driver for testing rational class
int tester(){
	try{
    while (!cin.fail()) {
    cout << endl << "Begin test of rational class. All tests effectively test output operator <<.";
	cin.get();
	if(cin.eof()) return -1; //Ctrl+Z is the end-of-file character - if someone inputs it, we need to get out of here
	//because all the rest of the inputs would be breezed through.

	//test default constructor
	cout << endl << "Testing default constructor." << endl;
	rational rdefault; //note lack of paren
	cout << rdefault; //should say 0/1
	cin.get();
	if(cin.eof()) return -1;

	//test n/n constructor
	int a = 2;
	int b = 3;
	cout << endl << "Testing n/n constructor with numerator " << a << " and denominator " << b << ".\n";
	rational rnovern(a,b);
	cout << rnovern;
	cin.get();
	if(cin.eof()) return -1;

    //test n/1 constructor
	int c = 4;
	cout << endl << "Testing n/1 constructor with numerator " << c << ".\n";
	rational rnover1(c);
	cout << rnover1;
	cin.get();
	if(cin.eof()) return -1;

	//test normalization
	rational normalizeme(15,30); //should become 1/2
	cout << endl << "Testing normalization with rational " << normalizeme << "." << endl;
	normalizeme = normalizeme.normalize(normalizeme);
	cout << normalizeme;
	cin.get();
	if(cin.eof()) return -1;

    //test normalization again (why not?)
	rational normalizeme2(11,33); //should become 1/3
	cout << endl << "Testing normalization with rational " << normalizeme2 << "." << endl;
	normalizeme2 = normalizeme2.normalize(normalizeme2);
	cout << normalizeme2;
	//cin.get(); //this can cause problems because of the cin coming up
	//if(cin.eof()) return -1;

    //test input operator >>
	rational test = rational();
	cout << endl << endl << "Testing input operator >>: ";
	cin >> test;
	cout << endl << "Your fraction is: " << test << " and normalized is: " << test.normalize(test) << endl;
	test = test.normalize(test);
	//cin.get(); //this can cause problems because of the cin coming up
	//if(cin.eof()) return -1;

    //get another user input for further tests
	rational test2 = rational();
	cout << endl << "Let's have a second rational: ";
	cin >> test2;
	cout << endl << "Your fraction is: " << test2 << " and normalized is: " << test2.normalize(test2) << endl;
	test2 = test2.normalize(test2);
	cin.get();
	if(cin.eof()) return -1;

	//test < operator
	bool testresult;
	cout << "Testing < operator..." << endl;
	testresult = normalizeme < normalizeme2;
	testresult = normalizeme2 < normalizeme;
	testresult = test < test2;
	cin.get();
	if(cin.eof()) return -1;

	//test > operator
	cout << "Testing > operator..." << endl;
	testresult = normalizeme2 > normalizeme;
	testresult = normalizeme > normalizeme2;
	testresult = test > test2;
	cin.get();
	if(cin.eof()) return -1;

	//test == operator
	rational half(1,2);
	cout << "Testing == operator..." << endl;
	testresult = normalizeme == normalizeme2;
	testresult = normalizeme == half;
	testresult = test == test2;
	cin.get();
	if(cin.eof()) return -1;

	//test + operator
	cout << "Testing + operator.\n";
	cout << test << " plus " << test2 << " equals " << (test + test2) << endl;
	cin.get();
	if(cin.eof()) return -1;

	//test - operator
	cout << "Testing - operator.\n";
	cout << test << " minus " << test2 << " equals " << (test - test2) << endl;
	cin.get();
	if(cin.eof()) return -1;

	//test * operator
	cout << "Testing * operator.\n(With multiplicands less than 1 (and greater than 0), your product will be less\nthan the multiplier.)\n";
	cout << test << " times " << test2 << " equals " << (test * test2) << endl;
	cin.get();
	if(cin.eof()) return -1;

	//test / operator
	cout << "Testing / operator.\n(With divisors less than 1 (and greater than 0), your quotient will be greater\nthan the dividend.)\n";
	cout << test << " divided by " << test2 << " equals " << (test / test2) << endl;
	cin.get();
	if(cin.eof()) return -1;

    //test / operator for divide-by-zero
	cout << "Testing / operator for divide by zero.\n(0/n, while a defined fraction, is 0. n/0 is undefined.)\n";
	cout << test << " divided by " << rdefault << " equals " << (test / rdefault) << endl;
	cin.get();
	if(cin.eof()) return -1;

	cout << "That's all for the tests. Thanks for participating!" << endl;
    cin.get();
	if(cin.eof()) return -1;

    return 0;
	}}
	catch (...){
	    cout << "An error occured. Exiting now.";
		return -1;
	}
    return -1;
}//end tester

//main "menu"
//program starts here
int main() {
	try{
    while (!cin.fail()) {
	int fnChoice = 0; //1 to run tests, 2 to run calculator, 3 to quit
	string fnChoiceIn;
	stringstream stream;
	while (fnChoice != 3) //3 quits
	{
	fnChoiceIn = ""; //clear string
	stream.str(""); 
	stream.clear(); //clear stream
	fnChoice = 0;
	cout << "Welcome to EZFrac, a simple fraction calculator.\nWould you like to run a test demonstration or start the calculator?" << endl;
	cout << "(You may enter Ctrl+C or Ctrl+Z to stop program at any time.)" << endl;
	cout << "Enter [1] for demonstration, [2] for calculator, [3] to exit: ";
	getline(cin, fnChoiceIn);
	if (cin.eof()) return -1; //if someone inputs Ctrl+Z
	stream << fnChoiceIn;
	stream >> fnChoice;
	if (fnChoiceIn.compare("") == 0) fnChoiceIn = "NOTHING";
	cout << "You chose " << fnChoiceIn << ".";
	if (!(fnChoice >= 1 && fnChoice <= 3)){ 
		
		cout << " " << fnChoiceIn << " is not a valid selection." << endl;
		cout << "Press Enter to continue." << endl;
	    cin.get();
		if (cin.eof()) return -1; //if someone inputs Ctrl+Z
	}
	cout << endl;
	if (fnChoice == 1)
		tester();
	else if (fnChoice == 2)
		calc();
	else if (fnChoice == 3)
	{
		cout << "Quitting now..." << endl;
	}
	}
	cout << "Press Enter to exit.";
	cin.get();
	if (cin.eof()) return -1; //if someone inputs Ctrl+Z
	return 0;
	}}
	catch (...){
	    cout << "An error occured. Exiting now.";
		return -1;
	}
}//end main